local FC = ...

function isManual(building, d)

	if FCconfig["balancing"]["progressOverride"][building]["manual unlock"] then else return d end

end

function registerVillage (name)
	FC:register({
		DataType = "TRADING_VILLAGE",
		Id = "FC_" .. string.upper(name),
		VillageName = name,
		UnlockCost = FCconfig["balancing"]["tradingVillages"][name]["unlock cost"],
		BuyingResourceList = FCconfig["balancing"]["tradingVillages"][name]["is buying"],
		SellingResourceList = FCconfig["balancing"]["tradingVillages"][name]["is selling"],
		Allegeance = FCconfig["balancing"]["tradingVillages"][name]["estate"]
	})
end

registerVillage ("Davenport")
registerVillage ("Northbury")
registerVillage ("Myddle")

FC:register({
	DataType = "TRADING_VILLAGE_LIST",
	Id = "FC_TRADING_VILLAGE_LIST",
	TradingVillageList = {
		"FC_DAVENPORT",
		"FC_NORTHBURY",
		"FC_MYDDLE"
	}
})

FC:register({
	DataType = "BUILDING_PROGRESS_LIST",
	Id = "FC_BUILDING_PROGRESS_LIST",
	ProgressList = {
		{
			AssetBuilding = "BUILDING_WOODCUTTER_CAMP",
			StatusQtyPair = FCconfig["balancing"]["progressOverride"]["lumber camp"]
		},
		{
			AssetBuilding = "BUILDING_GATHERING_CAMP",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["gathering hut"]
		},
		{
			AssetBuilding = "BUILDING_STONECUTTER_CAMP",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["stonecutter camp"]
		},
		{
			AssetBuilding = "BUILDING_SAWMILL",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["sawmill"]
		},
		--[[{
			AssetBuilding = "BUILDING_WELL",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["well"]
		},]]
		{
			AssetBuilding = "BUILDING_WAREHOUSE",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["warehouse"]
		},
	
		isManual("fisher's hut",{
			AssetBuilding = "BUILDING_FISHING_HUT",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["fisher's hut"]["requirement"]
		}),
		isManual("hunter's hut",{
			AssetBuilding = "BUILDING_HUNTERS_HUT",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["hunter's hut"]["requirement"]
		}),

		--[[{
			AssetBuilding = "BUILDING_WEAPONSMITH",
			StatusQtyPair= {Status ="NEWCOMER" , Quantity = 0}
		},
		{
			AssetBuilding = "BUILDING_WOODEN_GATE",
			StatusQtyPair= {Status ="NEWCOMER" , Quantity = 0}
		},]]
		{
			AssetBuilding = "BUILDING_STONEMASON_HUT",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["stonemason hut"]
		},
		{
			AssetBuilding = "BUILDING_FORESTER",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["forester camp"]
		},
		{
			AssetBuilding = "BUILDING_WHEAT_FARM",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["wheat farm"]
		},
		{
			AssetBuilding = "BUILDING_WINDMILL",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["windmill"]
		},
		{
			AssetBuilding = "BUILDING_BAKERY",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["bakery"]
		},
		{
			AssetBuilding = "BUILDING_SHEEP_FARM",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["sheep farm"]
		},
		{
			AssetBuilding = "BUILDING_WEAVER_HUT",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["weaver hut"]
		},
		{
			AssetBuilding = "BUILDING_TAILOR_WORKSHOP",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["tailor's workshop"]
		},
		{
			AssetBuilding = "BUILDING_COAL_HUT",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["coal hut"]
		},
		{
			AssetBuilding = "BUILDING_IRON_SMELTER",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["iron smelter"]
		},
		{
			AssetBuilding = "BUILDING_BLACKSMITH",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["blacksmith"]
		},
		{
			AssetBuilding = "BUILDING_IRON_MINE",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["iron mine"]
		},
		{
			AssetBuilding = "MONUMENT_MARKET",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["market"]
		},
		{
			AssetBuilding = "MONUMENT_WOODEN_BRIDGE",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["wooden bridge"]
		},

		isManual("lord manor",{
			AssetBuilding = "MONUMENT_RUSTIC_LORD_MANOR",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["lord manor"]["requirement"]
		}),
		isManual("wooden keep",{
			AssetBuilding = "MONUMENT_WOODEN_KEEP",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["wooden keep"]["requirement"]
		}),
		isManual("monastery",{
			AssetBuilding = "MONUMENT_MONASTERY",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["monastery"]["requirement"]
		}),
		isManual("church",{
			AssetBuilding = "MONUMENT_CHURCH",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["church"]["requirement"]
		}),

		{
			AssetBuilding = "MONUMENT_RUSTIC_CHURCH",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["rustic church"]
		},
		{
			AssetBuilding = "MONUMENT_STONE_BRIDGE",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["stone bridge"]
		},
		{
			AssetBuilding = "BUILDING_DECORATIVE_BUSH",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["decorative bush"]
		},
		{
			AssetBuilding = "BUILDING_FENCE",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["fence"]
		},
		{
			AssetBuilding = "BUILDING_ROAD_SIGN",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["road sign"]
		},
		--[[{
			AssetBuilding = "BUILDING_PLANT_ARCH",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["plant arch"]
		},]]
		{
			AssetBuilding = "BUILDING_DECORATIVE_TREE",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["decorative tree"]
		},
		{
			AssetBuilding = "BUILDING_DECORATIVE_CYPRES",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["cypress"]
		},
		{
			AssetBuilding = "BUILDING_FOUNTAIN",
			StatusQtyPair= FCconfig["balancing"]["progressOverride"]["fountain"]
		}
	}
})

FC:register({
	DataType = "BUILDING_PART_COST_LIST",
	Id = "FC_BUILDING_PART_COST_LIST",
	BuildingPartCostList = {
		{
			BuildingPart = "BUILDING_PART_WOODCUTTER_CAMP", 
			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["lumber camp"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["lumber camp"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["lumber camp"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_STONECUTTER_CAMP",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["stonecutter camp"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["stonecutter camp"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["stonecutter camp"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_GATHERING_CAMP",
			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["gathering hut"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["gathering hut"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["gathering hut"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_WELL",
			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["well"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["well"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["well"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_SAWMILL",
			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["sawmill"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["sawmill"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["sawmill"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_WAREHOUSE",
			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["warehouse"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["warehouse"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["warehouse"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_FISHING_HUT",
        		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["fisher's hut"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["fisher's hut"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["fisher's hut"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_FORESTER",
			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["forester camp"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["forester camp"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["forester camp"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_STONEMASON",
			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["stonemason hut"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["stonemason hut"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["stonemason hut"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_HOUSE_LVL1",
        		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["houselvl1"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["houselvl1"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["houselvl1"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_SHEEP_FARM",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["sheep farm"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["sheep farm"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["sheep farm"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_WEAVER_HUT",
			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["weaver hut"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["weaver hut"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["weaver hut"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_TAILOR_WORKSHOP",
       			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["tailor's workshop"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["tailor's workshop"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["tailor's workshop"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_WHEAT_FARM",
       			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["wheat farm"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["wheat farm"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["wheat farm"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_WINDMILL",
       			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["windmill"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["windmill"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["windmill"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_BAKERY",
        		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["bakery"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["bakery"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["bakery"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_IRON_MINE",
       			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["iron mine"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["iron mine"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["iron mine"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_IRON_SMELTER",
       			BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["iron smelter"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["iron smelter"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["iron smelter"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_BLACKSMITH",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["blacksmith"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["blacksmith"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["blacksmith"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_COAL_HUT",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["coal hut"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["coal hut"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["coal hut"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_MARKET_FOOD_STALL",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["food stall"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["food stall"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["food stall"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_MARKET_GOODS_STALL",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["goods stall"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["goods stall"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["goods stall"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_MARKET_LUXURY_STALL",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["luxury goods stall"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["luxury goods stall"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["luxury goods stall"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_DECORATIVE_BUSH",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["decorative bush"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["decorative bush"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["decorative bush"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_DECORATIVE_CYPRES",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["cypress"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["cypress"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["cypress"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_DECORATIVE_TREE",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["decorative tree"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["decorative tree"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["decorative tree"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_FENCE",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["fence"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["fence"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["fence"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_FOUNTAIN",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["fountain"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["fountain"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["fountain"]["building"]
			}
		},
		{
			BuildingPart = "BUILDING_PART_WOODEN_GATE",
            		BuildingPartCost = {
				BuildRightTaxes = FCconfig["balancing"]["costOverride"]["wooden gate"]["upfront"],
				UpkeepCost = FCconfig["balancing"]["costOverride"]["wooden gate"]["maintenance"],
				RessourcesNeeded = FCconfig["balancing"]["costOverride"]["wooden gate"]["building"]
			}
		},



	}

})